/* :: ekgedit project
   :: $Id: ekg2otak.c,v 1.1.1.1 2003/02/23 12:00:47 loth Exp $
   :: license: gnu gpl v 2
      copyright (c) 2002 - 2003 
   :: grzegorz moskal, <g.moskal@opengroup.org>			*/

#define EKG2OTAK_C
#include "ekg2otak.h"

static char *names[] = { "name", "last", "nick", "display", "phone", "groups", "uin" };
static char *base, *userlist;

static void parse_line(char *jmp, FILE *out)
{
	int i = Name;
	char *word;
	
	while (*jmp) {
		if (*jmp == ';') {
			jmp++;
			i++;
			continue;
		}
		
		word = strchr(jmp, ';');
		fprintf(out, "%s=", names[i]);
		
		for (; *jmp && jmp != word; jmp++) 
			fputc(*jmp, out);
			
		fprintf(out, "\n");
	}
	fprintf(out, "\n");
}

static void make_base(FILE *in, FILE *out)
{
	char *line;
	int i = 1;
	fprintf(stdout, "input  = %s\noutput = %s\n", userlist, base);
	fprintf(out, "#ekg2otak --in %s --out %s\n", userlist, base);
	while ((line = read_line(in))) {
		fprintf(out, "[%d]\n", i++);
		parse_line(line, out);
		xfree(line);
	}
	fclose(in);
	fclose(out);
}

int main(int argc, char **argv)
{
	if (parse_cmdline(argc, argv) == 0)
		return 0;
		
	if (userlist == NULL) 
		userlist = strdglue(getenv("HOME"), ".gg/userlist");
		
	if (base == NULL)
		base = strdglue(getenv("HOME"), ".otak/ekglist");
		
	make_base(xfopen(userlist, "r"), xfopen(base, "w+"));
	
	return 0;
}

static int parse_cmdline(int argc, char **argv)
{
	int i = 1;
	char *opt;
	for (; i < argc; i++)  {
		opt = argv[i];
		if (strcmp(opt, "--in") == 0) {
			if (i+1 < argc) 
				userlist = strdup(argv[++i]);
			else {
				printf("option --in needs <filname>\n");
				return 0;
			}
		} else if (strcmp(opt, "--out") == 0) {
			if (i+1 < argc) 
				base = strdup(argv[++i]);
			else {
				printf("option --out needs <filname>\n");
				return 0;
			}
		} else if (strcmp(opt, "--help") == 0) {
			printf("usage:  ekg2otak [options]\n\n"
				"--in   <filename>\tread ekg userlist from this file\n"
				"--out  <filename>\twrite otak database into this file\n"
				"--help           \tshow this info message\n\n");
			return 0;
		} else {
			printf("option \"%s\" !recognized ;(.\n", opt);
			printf("try: %s --help\n", argv[0]);
			return 0;
		}
	}
	return 1;
	
}
