/* :: ekgedit project
   :: $Id: xfnc.c,v 1.1.1.1 2003/02/23 12:00:47 loth Exp $
   :: license: gnu gpl v 2
      copyright (c) 2002 - 2003 
   :: grzegorz moskal, <g.moskal@opengroup.org>			*/

#define XFNC_C
#include "xfnc.h"

char *strglue(char *p1, char *space, char *p2)
{
	char *r = malloc(sizeof(char) * 
			(strlen(p1) + strlen(p2) + strlen(space) +1));
	sprintf(r,"%s%s%s", p1, space, p2);
	return r;
}

char *strdglue(char *p1, char *p2)
{
	return strglue(p1, "/", p2);
}

FILE *xfopen(char *name, char *mode)
{
	FILE *fd = fopen(name, mode);
	if (fd == NULL) {
		fprintf(stderr, "Can`t open file: %s\n", name);
		exit(1);
	}
	return fd;
}

void *xfree(void *ptr)
{
	if (ptr)
		free(ptr);
	return 0;
}

void xcp(char *sn, char *dn)
{
	FILE *src = fopen(sn, "r");
	FILE *dest = fopen(dn, "w+");
	if (src) {
		char *buf = xmalloc(sizeof(char)*200);
		*buf = 0;
		while ((buf = fgets(buf, 200, src)))
			fputs(buf, dest);
		xfree(buf);
		fclose(src);
	}
	fclose(dest);
}

char *read_line(FILE *fd)
{
	int i = 0, w = 6, c;
	char *tab = xmalloc(sizeof(char) * w);
	do {
		if (i >= w-2)
			tab = xrealloc(tab,(w*=2)*(sizeof(char)));
		c = fgetc(fd);
	
		if (c == EOF)
			return 0;
			
		if (c == '\r' || c == '\n') 
			continue;	

		tab[i++] = c;
		
	} while (c != '\n');
	tab[i] = 0;
	return i ? tab : read_line(fd);
}

void *xmalloc(size_t size)
{
	void *ptr;
	
	if (!size)
		return NULL;

	if ((ptr = calloc(1, size)) == NULL) {
		perror("calloc() failed");
		exit(1);
	}
	return ptr;
}

void *xrealloc(void *ptr, size_t size)
{

	if (!size)
		return NULL;
		
	ptr = realloc(ptr, size);
	
	if (ptr == NULL) {
		perror("realloc() failed");
		exit(1);
	}
	return ptr;
}


